【发布时间】:2015-12-17 13:07:31
【问题描述】:
我有 systemd 服务,比如 xyzWarmup.service。
这是服务文件
[Unit]
Description=Xyz agent.
After=fooAfter.service
Before=fooBefore1.service
Before=fooBefore2.service
[Service]
# During boot the xyz.sh script reads input from /dev/console. If the user
# hits <ESC>, it will skip waiting for xyz and abc to startup.
Type=oneshot
StandardInput=tty
StandardOutput=tty
ExecStart=/usr/bin/xyz.sh start
RemainAfterExit=True
ExecStop=/usr/bin/xyz.sh stop
[Install]
WantedBy=multi-user.target
以下是xyz.sh的部分。
#! /bin/bash
#
### BEGIN INIT INFO
# Required-Stop: Post
### END INIT INFO
XYZ=/usr/bin/Xyz
prog="Xyz"
lockfile=/var/lock/subsys/$prog
msg="Completing initialization"
start() {
# Run wfw in background
ulimit -c 0
# wfw has a default timeout of 10 minutes - just pick a large value
wfw -t 3600 xyz abc >/dev/null 2>&1 &
PID=$!
# Display the message here after spawning wfw so Esc can work
echo -n $"$msg (press ESC to skip): "
while [ 1 ]; do
read -s -r -d "" -N 1 -t 0.2 CHAR || true
if [ "$CHAR" = $'\x1B' ]; then
kill -9 $PID 2>/dev/null
# fall through to wait for process to exit
fi
STATE="`ps -p $PID -o state=`"
if [ "$STATE" = "" ]; then
# has exited
wait $PID 2>/dev/null
if [ $? -eq 0 ]; then
echo "[ OK ]"
echo
exit 0
else
echo "[ FAILED ]"
echo "This is failure"
exit 1
fi
fi
done
}
当此脚本在启动期间运行时,我看到来自脚本的以下消息
Completing initialization (press ESC to skip):
更新: 这是我在上一行之后看到的附加输出
[[ OK ] Started Xyz agent.\n'
如果你仔细看,有 2 个左方括号('['),从这里看起来 systemd 正在覆盖日志消息。第一个“[”来自 initscript 的“[ OK ]”。有人可以更好地解释一下吗?
我在屏幕上看不到“[ OK ]”或“[ FAILED ]”。
当我在 Fedora14 中将此脚本用作 initscript 时,我曾经看到这些消息。有一次,我已经转移到 systemd。我已经开始看到这个问题了。
systemd 版本为:systemd-201-2.fc18.9.i686 和 systemd.default_standard_output=tty
请帮忙。
【问题讨论】:
-
多次发布到多个堆栈交换:serverfault.com/questions/743861
-
您找到解决方案了吗?
标签: linux console fedora tty systemd